#include <iostream>
#include <vector>
using namespace std;
int pregled(string a)
{
    if(a[0]=='O') return 0;
    else if(a[0]=='A' && a[1]!='B') return 1;
    else if(a[0]=='B') return 2;
    else return 3;
}
int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    bool nemoguce;
	int n;
	cin>>n;
	vector<int> dostupnost(4);
	vector<int> potrebe(n);
	vector<vector<int>> predato(n, vector<int> (4));
	string pacijent;
	cin>>dostupnost[0]>>dostupnost[1]>>dostupnost[2]>>dostupnost[3];
	for(int i=0;i<n;i++)
    {
        vector<int> red(4);
        for(int j=0;j<4;j++)
        {
            red[j]=0;
        }
        predato.push_back(red);
    }
	for(int i=0;i<n;i++)
    {
        string a;
        cin>>a>>potrebe[i];
        if(pregled(a)==3)
        {
            pacijent[i]='C';
        }
        else pacijent[i]=a[0];
    }
    for(int i=0;i<n;i++)
    {
        if(pacijent[i]=='O')
        {
            if(potrebe[i]<=dostupnost[0])
            {
                dostupnost[0]-=potrebe[i];
                predato[i][0]+=potrebe[i];
            }
            else
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
        }
        else if(pacijent[i]=='A')
        {
            if(potrebe[i]<=dostupnost[0]+dostupnost[1])
            {
                if(potrebe[i]<=dostupnost[1])
                {
                    dostupnost[1]-=potrebe[i];
                    predato[i][1]+=potrebe[i];
                }
                else
                {
                    predato[i][1]=predato[i][1]+dostupnost[1];
                    potrebe[i]-=dostupnost[1];
                    dostupnost[1]=0;
                    dostupnost[0]-=potrebe[i];
                    predato[i][0]+=potrebe[i];

                }
            }
            else
            {
                cout<<"nemoguce"<<"\n";
                return 0;
            }
        }
        else if(pacijent[i]=='B')
        {
            if(potrebe[i]<=dostupnost[0]+dostupnost[2])
            {
                if(potrebe[i]<=dostupnost[2])
                {
                    dostupnost[2]-=potrebe[i];
                    predato[i][2]+=potrebe[i];
                }
                else
                {
                    predato[i][2]=predato[i][2]+dostupnost[2];
                    potrebe[i]-=dostupnost[2];
                    dostupnost[2]=0;
                    dostupnost[0]-=potrebe[i];
                    predato[i][0]+=potrebe[i];
                }
            }
            else
            {
                cout<<"nemoguce"<<"\n";
                return 0;
            }
        }
        else if(pacijent[i]=='C')
        {
            if(potrebe[i]<=dostupnost[0]+dostupnost[1]+dostupnost[2]+dostupnost[3])
            {
                if(potrebe[i]<=dostupnost[3])
                {
                    dostupnost[3]-=potrebe[i];
                    predato[i][3]+=potrebe[i];
                }
                else if(potrebe[i]<=dostupnost[1]+dostupnost[3] || potrebe[i]<=dostupnost[2]+dostupnost[3])
                {
                    if(potrebe[i]<=dostupnost[1]+dostupnost[3])
                    {
                        predato[i][3]+=dostupnost[3];
                        potrebe[i]-=dostupnost[3];
                        dostupnost[3]=0;
                        dostupnost[1]-=potrebe[i];
                        predato[i][1]+=potrebe[i];
                    }
                    else
                    {
                        predato[i][3]+=dostupnost[3];
                        potrebe[i]-=dostupnost[3];
                        dostupnost[3]=0;
                        dostupnost[2]-=potrebe[i];
                        predato[i][2]+=potrebe[i];
                    }
                }
                else
                {
                    predato[i][3]+=dostupnost[3];
                    potrebe[i]-=dostupnost[3];
                    dostupnost[3]=0;

                    predato[i][1]+=dostupnost[1];
                    potrebe[i]-=dostupnost[1];
                    dostupnost[1]=0;

                    predato[i][2]+=dostupnost[2];
                    potrebe[i]-=dostupnost[2];
                    dostupnost[2]=0;

                    dostupnost[0]-=potrebe[i];
                    predato[i][0]+=potrebe[i];
                }
            }
            else
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
        }
    }
    cout<<"moguce"<<endl;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<4;j++)
        {
            cout<<predato[i][j]<<" ";

        }
        cout<<endl;
    }
	return 0;
}